
import include, Ransac, virtLayout
from math import floor
from Shape import Point


"""
"""
class multiRef:
	
	# threshold
	# virtLayout
	# r, scale
	
	def __init__(self, layout=None):
		self.threshold = 20
		self.setSize = 0.6
		self.virtLayout = layout
	
	def fromConfig(self, cfg):
		self.virtLayout = virtLayout.virtLayout().fromConfig(cfg)
		return self
	
	def transRef(self, reference, image):
		try:
			r = reference.transformation(image)
			c = reference.position.leftTop + Point(floor(reference.width/2.0), floor(reference.height/2.0))
			p = [(c, r.transMatrix.calcPoint(Point(floor(reference.width/2.0), floor(reference.height/2.0))))]
			#print "Adding point", p[0][0], "->", p[0][1]
			
			for x in ((0, reference.position.leftTop.x), (reference.width, reference.position.rightBottom.x)):
				for y in ((0, reference.position.leftTop.y), (reference.height, reference.position.rightBottom.y)):
					p.append((Point(x[1],y[1]), r.transMatrix.calcPoint(Point(x[0],y[0]))))
					#print "Adding point", p[-1][0], "->", p[-1][1]
			
			return p
		except Exception:
			print "Reference %s (id=%s) not matched" % (reference.img.path, reference.id)
			return []
	
	def multiRef(self, image):
		pts = []
		for ref in self.virtLayout.references:
			# get edge and center points
			pts.extend(self.transRef(ref, image))
		
		# find the transformation matrix
		self.r = Ransac.Ransac(self.threshold)
		self.r.plainHomography(pts)
		
		# scale and offset
		self.scale = self.r.getScale(self.virtLayout)
		
		"""
		# Old code: applies ransac on the found points again
		# find the transformation matrix
		self.r = Ransac.Ransac(self.threshold)
		
		self.r.setSize = int(floor(len(pts) * self.setSize))
		self.r.calcMatrix(pts)
		
		# scale and offset
		self.scale = self.r.getScale(self.virtLayout)
		"""
		
		return self.r.transMatrix, self.scale


class App:

	def __init__(self):
		self.output = sys.stdout

	def run(self):
		self.parseArgs(sys.argv[1:])
		self.initialize()
		self.execute()
		self.printOut()
		return self

	def parseArgs(self, argv):
		import oParse
		
		try:
			
			opts, self.request = oParse.getopt(argv, ['h', 'i=', 'c='], ['help', 'config=', 'image='])
			for opt, arg in opts:
				if opt in ("-h", "--help"):
					self.helpAndExit(0)
				elif opt in ("-i", "--image"):
					self.imgPath = arg
				elif opt in ("-c", "--config"):
					self.cfgPath = arg
			
		except oParse.GetoptError, e:
			sys.stderr.write("An error was detected while parsing parameter: " + str(e) + '\n')
			self.helpAndExit(1)
		
		return self

	def initialize(self):
		self.image = custImage.custImage(self.imgPath)
		cfg = json.load(open(self.cfgPath, 'r'))
		self.refCluster = multiRef().fromConfig(cfg)
		return self

	def execute(self):
		self.matrix, self.scale = self.refCluster.multiRef(self.image)
		return self

	def printOut(self):
		print self.matrix, self.scale
		return self


	def helpAndExit(self, code=0):
		print "This script "
		print ""
		print "Usage: "
		print "Help"
		print "-h --help		This help"
		print "-c --config		Config file"
		print "-i --image		Input image"
		print ""
		print "The output will be "
		exit(code)




if __name__ == '__main__':
	import sys, json, custImage
	App().run()
