
import sys, re
sys.path.append('/home/matthias/projekte/cira/software/implementation/kommando/pyImp/modules/modPolynom/build/lib.linux-x86_64-2.6')
import modPolynom

from Shape import Point

class Polynom: pass
#	def __call__(self, x): return self.calcValue(x)

class PolyError(Exception): pass

def norm(poly, k):
	return [poly.coeff[i] * k**(i-1) for i in range(len(poly.coeff))]


# ptList: a0*x^0 + a1*x^1 + a2*x^2 + a3*x^3 + ... + an*x^n
#         [a0, a1, a2]
class cPoly(Polynom):

	def calcValue(self, value):
		return Point(value, sum([self.coeff[i]*value**i for i in range(len(self.coeff))]))

	# FIXME: use list operators
	# deriv:  a0*0*x^-1 + a1*1*x^0 + a2*2*x^1 + a3*3*x^2 + ... + an*n*x^(n-1)
	#         [a1, 2*a2, 3+a3, ...]
	def derivative(self):
		#self.coeff = map(lambda x, y: x*y, range(1, len(self.coeff)), self.coeff[1:])
		coeff = []
		for i in range(1, len(self.coeff)):
			coeff.append(self.coeff[i] * i)
		self.coeff = coeff

	def normPoints(self, k):
		poly = cPoly()
		poly.coeff = [self.coeff[i] * k**(i-1) for i in range(len(self.coeff))]
		return poly

	def toDataPoly(self, samples):
		pts = [self.calcValue(i) for i in samples]
		self.buddy = dPoly().initByPoints(pts)
		return self.buddy

	def initByPoints(self, pts, k):
		x = [p.x for p in pts]
		y = [p.y for p in pts]
		try:
			self.coeff = modPolynom.polynom(x, y, k)
		except Exception, e:
			raise PolyError(str(e))
		return self

	def initByCoeff(self, coeff, reverse=False):
		self.coeff = coeff[:]
		if reverse: self.coeff.reverse()
		return self

	def asString(self, expStyle='^'):
		return self.__str__(expStyle)

	def __str__(self, expStyle='^'):
		def sign(x):
			if x < 0: return ' - '
			else: return ' + '

		if len(self.coeff) == 0: return '0'
		if len(self.coeff) > 0: s = str(self.coeff[0])
		if len(self.coeff) > 1: s += sign(self.coeff[1]) + str(abs(self.coeff[1])) + '*u'
		if len(self.coeff) > 2: s += ''.join([sign(self.coeff[i]) + str(abs(self.coeff[i])) + '*u' + expStyle + str(i) for i in range(2, len(self.coeff))])
		return s


class dPoly(Polynom):
	def transform(self, trans):
		return trans.transPolynom(self)
	
	def toCoeffPoly(self, k):
		self.buddy = cPoly().initByPoints(self.points, k)
		return self.buddy
	
	def initByPoints(self, pts):
		self.points = pts
		return self

	def __str__(self):
		return '[' + '; '.join([str(p) for p in self.points]) + ']'

	def invert(self):
		for p in self.points: p.x, p.y = p.y, p.x
