
from math import floor
from Shape import Point, Square

class Transform:
	"""Handle affine transformations."""

	"""
	 * In case of SINGLE transformation
	 * Origin point as object of Coord
	"""
	#point = None

	"""
	 * In case of SQUARE transformation
	 * Corner points as object of Square
	"""
	#square = None

	"""
	 * In case of SQUARE transformation
	 * x/y scaling factors
	"""
	# scale = (0, 0)

	"""
	 * In case of MATRIX transformation
	 * Transformation matrix as object of Matrix33
	"""
	#matrix = None

	# 
	#method = ''

	def __init__(self):
		pass


	def initByArbitrary(self, data0, data1=None):
		if isinstance(data, Point):
			return self.initBySingle(data0, data1)
		elif isinstance(data, Square):
			return self.initBySquare(data0, data1)
		elif isinstance(data, Matrix33):
			return self.initByMatrix(data)

	def initBySingle(self, ptTrans, ptOrig=None):
		if ptOrig == None:
			self.point = ptTrans
		else:
			self.point = Point(ptTrans.x - ptOrig.x, ptTrans.y - ptOrig.y)
		self.transPoint, self.invert = self.__mSingle, self.__iSingle
		return self

	def initBySquare(self, offset, scale):
		self.point = offset
		self.scale = scale
		self.transPoint, self.invert = self.__mSquare, self.__iSquare
		return self

	def initByMatrix(self, matrix):
		self.matrix = matrix;
		self.transPoint, self.invert = self.__mMatrix, self.__iMatrix
		return self

	def __mSingle(self, point):
		return Point(self.point.x + point.x, self.point.y + point.y);

	def __mSquare(self, point):
		x = floor(point.x * self.scale[0]) + self.point.x;
		y = floor(point.y * self.scale[1]) + self.point.y;
		return Point(x, y);

	def __mMatrix(self, point):
		return self.matrix.transform(point)

	def __iSingle(self):
		return Transform().initBySingle(Point(-1*self.point.x, -1*self.point.y))

	def __iSquare(self):
		off = Point(-1*float(self.point.x)/self.scale[0], -1*float(self.point.y)/self.scale[0])
		sc  = (1.0/self.scale[0], 1.0/self.scale[1])
		return Transform().initBySquare(off, sc)

	def __iMatrix(self):
		return Transform().initByMatrix(self.matrix.invert())

	def transSquare(self, square):
		return Square(self.transPoint(square.leftTop), self.transPoint(square.rightBottom))

	def transPolynom(self, polynom):
		return dPoly().initByPoints([self.transPoint(p) for p in polynom.points])

	def __str__(self):
		raise Exception('class Transformation cannot be converted into a string')



if __name__ == '__main__':
	pass

