
from Shape import Point, Square
from math import sqrt

class iPoint(Point):
	"""Feature wrapper."""
	
	# double scale
	# double strength
	# double ori
	# int laplace
	# double ivec
	
	def __init__(self, pos=(0,0), scale=0.0, laplace=0, strength=0.0, ori=0.0, ivec=[]):
		if isinstance(pos, Point):	Point.__init__(self, pos.x, pos.y)
		else:				Point.__init__(self, pos[0], pos[1])
		
		self.laplace = laplace
		self.scale = scale
		self.strength = strength
		self.ori = ori
		self.ivec = ivec
		

	def fromRaw(self, lst):
		x, y, a, b, c, self.laplace, self.strength, self.ori = lst[0:8]
		
		# position
		self.set(x,y)
		
		# iVec
		self.ivec = lst[8:]
		
		# scale
		det = sqrt((a-c)*(a-c) + 4.0*b*b)
		e1 = 0.5*(a+c + det)
		e2 = 0.5*(a+c - det)
		l1 = (1.0/sqrt(e1))
		l2 = (1.0/sqrt(e2))
		sc = sqrt( l1*l2 )
		self.scale = sc/2.5
		
		return self

	def dist(self, other):
		return sum([(self.ivec[i] - other.ivec[i])**2 for i in range(len(self.ivec))])

	def asRaw(self):
		sc = (2.5*self.scale)**2
		return [self.x, self.y, 1.0/sc, 0.0, 1.0/sc, self.laplace, self.strength, self.ori] + self.ivec
