
def GetoptError(Exception): pass

# args: argument list
# short: short argument names
# long:  long argument names
def getopt(args, short, long):

	# insert '-' and '--'
	short = map(lambda x: '-' + str(x), short)
	long = map(lambda x: '--' + str(x), long)
	
	# divide into args / noargs
	withArgs = filter(lambda x: x[-1] == '=', short + long)
	noArgs = filter(lambda x: x not in withArgs, short + long)
	withArgs = map(lambda x: x[0:-1], withArgs)
	
	opts = []
	curArg = None
	err = []
	rest = []
	for arg in args:
		if arg in withArgs: # -p val, --param val
			if curArg != None: raise GetoptError(curArg)
			curArg = arg
		elif arg in noArgs: # -p, --param
			if curArg != None: raise GetoptError(curArg)
			opts.append((arg, ''))
		elif len(arg) > 1 and arg[1] != '-' and arg[0:2] in noArgs: # -fgh
			opts += [('-' + s,'') for s in arg[1:]]
		else:
			for item in withArgs: # -p=val, --param=val
				if arg[0:len(item)] == item:
					curArg = item
					arg = arg[len(item)+1:]
					break
			
			if curArg != None:
				opts.append((curArg, arg))
				curArg = None
			else:
				rest.append(arg)
	
	return opts, rest

