
import include, custImage, ptMatch, Ransac


class positionReference:
	"""Handle position reference information"""

	# img		Image resource
	# threshold	ransac threshold
	# position	position square

	def __init__(self, path=None, threshold=10):
		self.doubleSize = True
		self.img = None
		if path != None: self.img = custImage.custImage(path)
		self.threshold = threshold


	def __getattr__(self, name):
		if name == 'width':		return self.img.width
		elif name == 'height':		return self.img.height
		raise AttributeError()

	def fromConfig(self, cfg):
		self.img = custImage.custImage(cfg['file'])
		self.threshold = float(cfg['threshold'])
		self.id = cfg['id']
		self.size = cfg['size'].split(',')
		return self

	def __str__(self):
		raise Exception('Class Reference cannot be converted into a string')

	def transformation(self, img):
		matching = ptMatch.ptMatch(self.doubleSize, self.img).match(ptMatch.ptMatch(self.doubleSize, img))
		
		r = Ransac.Ransac(self.threshold)
		r.setSize = 5
		r.calcMatrix(matching)
		return r
