
from positionReference import positionReference
from Shape import Point, Square
from mCalc2 import mCalc

"""
 Layout defined by:
 * Reference images
 * Reference position (egdes + center)
"""
class virtLayout(Square):
	"""Handle virtual layouts."""
	
	# width:  Int; Calculated by reference fixpoints
	# height: Int; Calculated by reference fixpoints
	# references (custImage) with fixpoint method <-- JSON !!
	# metric: Used metric (mCalc)

	def __init__(self):
		"""
		
		Init this class by virtLayout().fromConfig(cfgFile)
		"""
		self.references = []

	def fromConfig(self, cfg):
		layout = cfg['referenceLayout']
		isFirst = True
		for key in layout:
			if len(key) > 1: continue
			# reference
			refConfig = filter(lambda r: r['id'] == key, cfg['geometryReference'])
			if len(refConfig) != 1: raise Exception('Misconfiguration: id = ' + str(key) + '; ' + str(refConfig))
			ref = positionReference().fromConfig(refConfig[0])
			self.references.append(ref)
			
			# !! VERY UGLY - RECODE LATER !!
			if isFirst:
				self.metric = mCalc((ref.width, ref.height), ref.size)
				isFirst = False
			
			# layout information
			leftTop = self.metric.parse(layout[key])
			ref.position = Square(leftTop, Point(leftTop.x + ref.width, leftTop.y + ref.height))
			self.metric.setFixSquare(ref.position, key)
		
		leftTop = Point(min([ref.position.leftTop.x for ref in self.references]), min([ref.position.leftTop.y for ref in self.references]))
		rightBottom = Point(max([ref.position.rightBottom.x for ref in self.references]), max([ref.position.rightBottom.y for ref in self.references]))
		Square.__init__(self, leftTop, rightBottom)
		
		# set self.width, self.height
		#self.width = max([ref.position.rightBottom.x for ref in self.references]) - min([ref.position.leftTop.x for ref in self.references])
		#self.height = max([ref.position.rightBottom.y for ref in self.references]) - min([ref.position.leftTop.y for ref in self.references])
		return self
