

// Calculate square distance of two vectors
double distSquare(double *v1, double *v2, int n) {
	double dsq = 0.;
	while (n--) {
		dsq += (*v1 - *v2) * (*v1 - *v2);
		v1++;
		v2++;
	}
	return dsq;
}



// Find closest interest point in a list, given one interest point
int findMatch(Ipoint *ip1, const Ipoint ipts[], int count, int vlen) {
	double mind = 1e100, second = 1e100;
	int match = -1;
	unsigned i;
	
	for (i = 0; i < count; i++) {
		// Take advantage of Laplacian to speed up matching
		if (ipts[i].laplace != ip1->laplace)
			continue;

		double d = distSquare(ipts[i].ivec, ip1->ivec, vlen);

		if (d < mind) {
			second = mind;
			mind = d;
			match = i;
		} else if (d < second) {
			second = d;
		}
	}

	if (mind < 0.5 * second)
		return match;

	return -1;
}

// Find all possible matches between two images

int findMatches(Ipoint ipts1[], Ipoint ipts2[], int size1, int size2, int vlen, p_list points[]) {


	int c = 0;
	unsigned i;
	for (i = 0; i < size1; i++) {
		int match = findMatch(&(ipts1[i]), ipts2, size2, vlen);
		if (match != -1) {
			points[c].first = i;
			points[c].second = match;
			c++;
		}
	}
	
	return c;
}


















