
#include <gsl/gsl_matrix.h>

/**
 * Used algorithm
 */
// multReg or dlt
#define MODEL_FUNCTION(basis, img, count, model) cv_homography(basis, img, count, model)

#define MODEL_POINTS 4



/**
 * DLT Algorithm
 */
bool dlt(vec basis[], vec img[], int dim, matrix model);

bool dltn(vec basis[], vec img[], int dim, matrix model);

/**
 * MULTIPLE REGRESSION
 */
bool multReg(vec basis[], vec img[], int dim, matrix model);

/**
 * HOMOGRAPHY
 */
//bool homography(vec basis[], vec img[], int dim, matrix model);

/**
 * OpenCV HOMOGRAPHY
 */
bool cv_homography(vec basis[], vec img[], int dim, matrix model);

/**
 * Convert gsl_matrix to matrix
 */
void gslColToH(gsl_matrix *m, int column, matrix h);

/**
 * Invert a gsl matrix
 */
gsl_matrix* gsl_invert(gsl_matrix *In);



void gslPrintVector(gsl_vector* v, char *name);
void gslPrintMatrix(gsl_matrix *m, char *name);
gsl_matrix *transform(vec basis[], int dim);
gsl_matrix* matrixToGsl(matrix m);
void gslToMatrix(gsl_matrix *Z, matrix m);
void gsl_calcPoint(gsl_matrix *m, vec src, vec dst);
